   import java.io.*;
   import java.util.*;

    public class TestQuestion3
   {

       public void createSuggestionsFile()
      {
         try
         {
            PrintWriter out = new PrintWriter(new FileWriter("suggestions.txt"));
         }
             catch(IOException e)
            {
               System.out.println("Suggestion File Error!!!"+e.getMessage());
                     
            }
      }
   
    public boolean validateAccNum(String accNo)
      {
         boolean validAccNo = false;
         if (accNo.length() == 7 && Character.isLetter(accNo.charAt(0))) 
         {
            validAccNo = true;
         }
         return validAccNo;
      }

          	
           
       public static void main (String [] args)
      {
         TestQuestion3 obj = new TestQuestion3();
         obj.createSuggestionsFile();
      
      
         
         String [] refNumbers = new String [100];
         String [] query = new String [100];
         int countRefNumbers =0;
         int countComplaints = 0;
         int countSuggestions = 0;
         int countPayments = 0;
         int countAccounts = 0;
      
      
      
         Scanner input = new Scanner(System.in);
         char ch = ' ';
         while (ch != 'Q')
         {
            
            System.out.println();
            System.out.println("         Menu");
            System.out.println(" ");
            System.out.println("       Option A");
            System.out.println("       Option B"); 
            System.out.println(" ");
            System.out.println("       Q - QUIT");
            System.out.println(" ");
            System.out.print("       Your choice? ");
            
             
            ch = input.nextLine().toUpperCase().charAt(0);
            switch (ch)
            {
               case 'A':
                  {                  
                  
                     try
                     {
                        Scanner sc = new Scanner (new FileReader("data.txt"));
                        while (sc.hasNext())
                        {
                           String line = sc.nextLine();
                           int psnColon = line.indexOf(":");
                           int lastPsnColon = line.lastIndexOf(":");
                           String accNo = line.substring(psnColon+1,lastPsnColon);
                           int psnHash = line.indexOf("#");
                           String date = line.substring(lastPsnColon+1,psnHash);
                        
                           String querie = line.substring(psnHash+1);
                        
                           char type =line.charAt(0);
                        
                           if (obj.validateAccNum(accNo)) 
                           {
                           
                              if (type == 'S')
                              {
                                 try
                                 {
                                    PrintWriter out = new PrintWriter(new FileWriter("suggestions.txt",true));
                                    out.println(line.substring(psnColon+1));
                                    out.close();
                                 }
                                     catch(IOException e)
                                    {
                                       System.out.println("Suggestion Error!!!"+e.getMessage());
                                    
                                    }
                              }//if
                              
                              else
                              {
                                 type = Character.toUpperCase(type);
                                 switch(type)
                                 {
                                    case 'C': countComplaints++;refNumbers[countRefNumbers] = "C"+countComplaints+"-"+accNo+"-"+date;
                                       break;
                                    case 'A': countAccounts++;refNumbers[countRefNumbers] = "A"+countAccounts+"-"+accNo+"-"+date;
                                       break;
                                 }
                                 query[countRefNumbers] = querie;
                                 countRefNumbers++;			 
                              }//else
                           
                                        
                           }//if
                        		  
                        
                        }//while
                     }//try
                         catch(FileNotFoundException e)
                        {
                           System.out.println("Error!!!"+e.getMessage());
                        }
                  		
                          
                  		
                     System.out.println("Reference Numbers\n=================");
                     for (int i = 0; i<countRefNumbers;i++)
                     {
                        System.out.println(refNumbers[i]);
                     
                     }//for
                  
                   
                     break;
                  }
                
               case 'B':
                  {
                     Scanner kb = new Scanner (System.in);
                  
                     System.out.println("Enter the account number to query");
                     String accNumber = kb.next();
                     boolean found = false;
                     System.out.println();
						   if (!(obj.validateAccNum(accNumber)))
          				   System.out.println("Invalid account number");
					  		else	          
    						{  
                     	for (int i = 0; i< countRefNumbers; i++)
                    		 {
                          if (refNumbers[i].contains(accNumber))
                          {
                            System.out.println(refNumbers[i]+"\t"+query[i]);
                            found =true;
                          }//if
                        }//for
							
                     if (!found)
                     {
                        System.out.println("No issues have been reported for account number:"+accNumber);
                     }
                   }// else                               
                  
                  
                     break; 
                  }
                
                        
               case 'Q':
                  {
                     System.exit(0);
                  } // case
                    
            } // switch
                
         } // while          
      }
   
      
   
   }//class